import { QueryHandler } from '@nestjs/cqrs';
import { ICollection } from 'src/modules/database/src/interfaces/collection.interface';
import { UsersRepository } from '../../adapters/secondaries/users.repository';
import { FindAllUsersQuery } from '../../queries/find-all-users.query';
import { User } from '../entities/user';

@QueryHandler(FindAllUsersQuery)
export class FindAllUsersUseCase {
  constructor(private readonly _repository: UsersRepository) {}

  async execute(
    findAllUsersQuery: FindAllUsersQuery,
  ): Promise<ICollection<User>> {
    return this._repository.findAll(
      findAllUsersQuery.page,
      findAllUsersQuery.perPage,
    );
  }
}
